1
0
mirror of https://gitlab.com/fdroid/fdroidserver.git synced 2024-07-07 09:50:07 +02:00
fdroidserver/hooks/pre-commit
2015-03-05 15:24:52 +01:00

79 lines
1.6 KiB
Bash
Executable File

#!/bin/sh
#
# Simple pre-commit hook to check that there are no errors in the fdroidserver
# source files.
# Redirect output to stderr.
exec 1>&2
PY_FILES="fdroid makebuildserver setup.py examples/*.py buildserver/*.py fdroidserver/*.py"
SH_FILES="hooks/pre-commit"
BASH_FILES="fd-commit jenkins-build docs/update.sh completion/bash-completion"
RB_FILES="buildserver/cookbooks/*/recipes/*.rb"
# In the default configuration, the checks E123, E133, E226, E241 and E242 are
# ignored because they are not rules unanimously accepted
# On top of those, we ignore:
# * E501: line too long (82 > 79 characters)
# - Recommended for readability but not enforced
# - Some lines are awkward to wrap around a char limit
# * W503: line break before binary operator
# - It's quite new
# - Quite pedantic
PEP8_IGNORE="E123,E133,E226,E241,E242,E501,W503"
err() {
echo ERROR: "$@"
exit 1
}
cmd_exists() {
command -v $1 1>/dev/null
}
if cmd_exists pyflakes-python2; then
PYFLAKES=pyflakes-python2
elif cmd_exists pyflakes; then
PYFLAKES=pyflakes
else
err "pyflakes is not installed!"
fi
if cmd_exists pep8-python2; then
PEP8=pep8-python2
elif cmd_exists pep8; then
PEP8=pep8
else
err "pep8 is not installed!"
fi
if ! $PYFLAKES $PY_FILES; then
err "pyflakes tests failed!"
fi
if ! $PEP8 --ignore=$PEP8_IGNORE $PY_FILES; then
err "pep8 tests failed!"
fi
for f in $SH_FILES; do
if ! dash -n $f; then
err "dash tests failed!"
fi
done
for f in $BASH_FILES; do
if ! bash -n $f; then
err "bash tests failed!"
fi
done
for f in $RB_FILES; do
if ! ruby -c $f 1>/dev/null; then
err "ruby tests failed!"
fi
done
exit 0